
import java.sql.Connection;
import java.sql.Statement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.DriverManager;
import java.sql.SQLException;

//import javax.sql.DataSource;

public class MysqlCount {

    static final String mysqlDriver = "com.mysql.jdbc.Driver";

    static String dbConnect = "jdbc:mysql://127.0.0.1/inet";
    static String user = "user";
    static String pword = "";

    public static void main(String[] args) {

        // load mysql driver
	try {
	    Class.forName( mysqlDriver );
	    System.out.println("mysqlDriver " + mysqlDriver + " loaded");
	} catch (ClassNotFoundException e) {
	    e.printStackTrace();
	}

        // connect to database
	Connection dbCon = null;
	try {
	    dbCon = DriverManager.getConnection(dbConnect,user,pword);
	    System.out.println("connected to " + dbConnect);
	    dbCon.setAutoCommit( false );
	} catch (SQLException e) {
	    e.printStackTrace();
	}
	if ( dbCon == null ) {
	    return;
	}

        // work with database
	// increment all counters
	Statement stmt = null;
	PreparedStatement ustmt = null;
	ResultSet rs = null;
	String query = "SELECT url, count FROM counter";
	String update = "UPDATE counter SET count = count + 1 WHERE url = ?";
	try {
            stmt = dbCon.createStatement();
	    System.out.println("statement created " + stmt);
            ustmt = dbCon.prepareStatement(update);

	    rs = stmt.executeQuery( query );
	    while ( rs.next() ) {
		String u = rs.getString(1);
		int c = rs.getInt("count");
                System.out.println("u = " + u + ", c = " +c);
		ustmt.setString(1, u );
		int rows = ustmt.executeUpdate();
                System.out.println(""+ustmt + "\nrows = " + rows);
	    }
	    dbCon.commit();
	    rs.close();
	    rs = null;
	    if ( stmt != null ) {
               stmt.close();
	       rs = null;
	    }
	    if ( ustmt != null ) {
               ustmt.close();
	       ustmt = null;
	    }
	} catch (SQLException e) {
	    try { 
                dbCon.rollback();
	    } catch (SQLException e1) { 
            }
	    e.printStackTrace();
	}

	try {
            if ( dbCon != null ) {
               dbCon.close();
               System.out.println(dbConnect + " closed");
	       dbCon = null;
	    }
	} catch (SQLException e) {
	    e.printStackTrace();
	}

    }

}
